from django.shortcuts import render, redirect
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from .forms import ImageCreateForm
from django.shortcuts import get_object_or_404
from .models import Image
from django.http import JsonResponse
from django.views.decorators.http import require_POST
from django.http import HttpResponse
from django.core.paginator import Paginator, EmptyPage, \
                                  PageNotAnInteger
from actions.utils import create_action
import redis
from django.conf import settings

# Nawiązanie połączenia z bazą danych Redis. 
r = redis.Redis(host=settings.REDIS_HOST,
                port=settings.REDIS_PORT,
                db=settings.REDIS_DB)

@login_required
def image_create(request):
    if request.method == 'POST':
        # formularz został wysłany
        form = ImageCreateForm(data=request.POST)
        if form.is_valid():
            # dane formularza są prawidłowe
            cd = form.cleaned_data
            new_image = form.save(commit=False)
            # przypisanie bieżącego użytkownika do elementu
            new_image.user = request.user
            new_image.save()
            create_action(request.user, 'dodał obraz', new_image)
            messages.success(request,
                             'Obraz został dodany.')
            # przekierowanie do widoku szczegółowego dla nowo utworzonego elementu
            return redirect(new_image.get_absolute_url())
    else:
        # utworzenie formularza na podstawie danych dostarczonych przez bookmarklet w żądaniu GET
        form = ImageCreateForm(data=request.GET)
    return render(request,
                  'images/image/create.html',
                  {'section': 'images',
                   'form': form})

def image_detail(request, id, slug):
    image = get_object_or_404(Image, id=id, slug=slug)
    # Inkrementacja o 1 całkowitej liczby wyświetleń danego obrazu.
    total_views = r.incr(f'image:{image.id}:views') 
    # Inkrementacja o 1 rankingu danego obrazu
    r.zincrby('image_ranking', 1, image.id) 
    return render(request,
                  'images/image/detail.html',
                  {'section': 'images',
                   'image': image,
                   'total_views': total_views}) 

@login_required
@require_POST
def image_like(request):
    image_id = request.POST.get('id')
    action = request.POST.get('action')
    if image_id and action:
        try:
            image = Image.objects.get(id=image_id)
            if action == 'lubię':
                image.users_like.add(request.user)
                create_action(request.user, 'polubił', image)
            else:
                image.users_like.remove(request.user)
            return JsonResponse({'status': 'ok'})
        except Image.DoesNotExist:
            pass
        return JsonResponse({'status': 'error'})

@login_required
def image_list(request):
    images = Image.objects.all()
    paginator = Paginator(images, 8)
    page = request.GET.get('page')
    images_only = request.GET.get('images_only')
    try:
        images = paginator.page(page)
    except PageNotAnInteger:
        # Jeżeli zmienna page nie jest liczbą całkowitą, wówczas pobierana jest pierwsza strona wyników.
        images = paginator.page(1)
    except EmptyPage:
        if images_only:
            # Jeżeli żądanie jest w technologii AJAX i zmienna page ma wartość spoza zakresu,
            # wówczas zwracana jest pusta strona.
            return HttpResponse('')
        # Jeżeli zmienna page ma wartość większą niż numer ostatniej strony wyników, wtedy pobierana # jest ostatnia strona wyników.
        images = paginator.page(paginator.num_pages)
    if images_only:
        return render(request,
                      'images/image/list_images.html',
                      {'section': 'images',
                      'images': images})
    return render(request,
                  'images/image/list.html',
                   {'section': 'images',
                    'images': images})

@login_required 
def image_ranking(request):
    # Pobranie słownika rankingu obrazów. 
    image_ranking = r.zrange('image_ranking', 0, -1,                               
                             desc=True)[:10]
    image_ranking_ids = [int(id) for id in image_ranking]
    # Pobranie najczęściej wyświetlanych obrazów.  
    most_viewed = list(Image.objects.filter(
                            
                       id__in=image_ranking_ids))
    most_viewed.sort(key=lambda x: image_ranking_ids.index(x.id))
    return render(request, 
                  'images/image/ranking.html',
                  {'section': 'images',
                   'most_viewed': most_viewed}) 



